#include <string>
#include <assert.h>
#include <stdio.h>
#include <port.h>
#include "aux.h"
#include "../../common/bits.h"

void nameNum( const string &n, string &name, unsigned long long &num )
{
   unsigned long long i;
   for( i = 0; ! isdigit( n[ i ] ); i++ );
   name = n.substr( 0, i );
   if (i<n.length())
   	num = atoi( n.substr( i, n.length() - i ).c_str() );
}
	    
  
unsigned long long stolli(const string str){
	unsigned long long val=0;
	unsigned long long aux,neg=0;

	if (str[0]=='-') {
		neg=1;
		aux=1;
	} else if (str[0]=='+')	{
		aux=1;
	} else if ((str[0]>='0')  && (str[0]<='9'))
		aux=0;
	else assert(0);
		

	for(unsigned long long i=aux; i<str.length(); i++){
		aux=str[i]-'0';
		assert( ((aux>=0) || (aux<=9)) );
		val=val*10+aux;
	}

	return val;
}

string llitos( const unsigned long long i )
{
   char buf[20];
   sprintf( buf, "%Lu", i );
   return string( buf );
}

Port **addPorts( PortType portType, const string &basename, unsigned long long number, Atomic &m, unsigned long long start = 0)
{
   Port **r=new (Port *)[number];
   
   for( unsigned long long i = 0; i < number; i++ )
      if( portType == ptInput )
            r[i] = & m.addInputPort( basename + llitos( i + start ) );
      else
            r[i] = & m.addOutputPort( basename + llitos( i + start ) );
      return r;
}
				       
Port **addPorts( PortType portType, const string nameList[], unsigned long long number, Atomic &m)
{
   Port **r = new (Port *)[number];
   for( unsigned long long i = 0; i < number; i++ )
      if( portType == ptInput )
            r[i] = & m.addInputPort( nameList[i] );
      else
            r[i] = & m.addOutputPort( nameList[i] );
      return r;
}

	 
unsigned long long log2(unsigned long long val){
	unsigned long long i;
	for(i=0; (val%2)!=1; i++)
		val>>=1;
	assert(val==1);

	return i;	
}

unsigned long long pow2(unsigned long long val){
	unsigned long long r=1;
	for(unsigned long long i=0; i<val;i++){
		r<<=1;
	}
	return r;
}


unsigned long long fromBits( const bit b[], unsigned long long nbits = defnbits )
{
   unsigned long long r = 0;
   for( unsigned long long i = 0; i < nbits; i++ ){
		assert ( ((b[i]==0) || (b[i]==1)) );
      	r |= b[ i ] << i;
      }
   return r;
}

unsigned long long fromBits( const o_bit b[], unsigned long long nbits = defnbits )
{
   unsigned long long r = 0;
   for( unsigned long long i = 0; i < nbits; i++ ){
		assert ( ((b[i].val==0) || (b[i].val==1)) );
      	r |= b[ i ].val << i;
      }
   return r;
}

void toBits( unsigned long long v, o_bit b[], unsigned long long nbits = defnbits )
{
   for( unsigned long long i = 0; i < nbits; i++ )
   {
      b[ i ].val = v % 2;
      v >>= 1;
   }
}

void toBits( unsigned long long v, bit b[], unsigned long long nbits = defnbits )
{
   for( unsigned long long i = 0; i < nbits; i++ )
   {
      b[ i ] = v % 2;
      v >>= 1;
   }
}
