#ifndef __SAMPLE_LA_H__
#define __SAMPLE_LA_H__

#include <atomic.h>
#include "../../common/bits.h"
#include <string>



class sampleLA: public Atomic {

 public:
	sampleLA( const string &name="sampleLA");
	~sampleLA();
	virtual string className() const{ return "sampleLA"; }
protected:
	Model &initFunction();
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );
private:


	enum InputPorts 	{busyin, dtackin,errin,rwin,resetin,asin,bgrantin};
	enum OutputPorts 	{busyout, dtackout,errout,rwout,resetout,asout, bgrantout };

	Port		
			**m_ctlInPorts,		**m_ctlOutPorts,
			**m_addrInPorts,	**m_addrOutPorts,
			**m_bselInPorts,	**m_bselOutPorts,
			**m_dataInPorts,	**m_dataOutPorts; 		

	const static unsigned long long
							 m_addrWidth = 32,
							 m_dataWidth = 32,
							 m_bselWidth = 4,
							 m_byteSize = m_dataWidth/m_bselWidth;

	Time m_responseTime;
	
	enum State {waiting,sending};

	State m_state;



	
	unsigned long long m_minAddrSpaceLimit;
	unsigned long long m_maxAddrSpaceLimit;
	
	bit		*m_ctlIn,
			*m_addrIn, 
			*m_bselIn, 
			*m_dataIn;
			
	o_bit 	*m_ctlOut, 
			*m_addrOut, 
			*m_bselOut, 
			*m_dataOut;
	
};

#endif
