#ifndef __SAMPLE_LT_H__
#define __SAMPLE_LT_H__

#include <atomic.h>
#include "../../common/bits.h"
#include <string>



class sampleLT: public Atomic {

 public:
	sampleLT( const string &name="sampleLT");
	~sampleLT();
	virtual string className() const{ return "sampleLT"; }
protected:
	Model &initFunction();
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );
private:


    enum InputPorts  {busycpuin,busybusin, dtackin,errin,rwin,resetin,asin,bgrantin };
	enum OutputPorts {busycpuout,busybusout, dtackout,errout,rwout,resetout,asout, bgrantout, busycpu };

	Port		
			**m_ctlInPorts,		**m_ctlOutPorts,
			**m_addrInPorts,	**m_addrOutPorts,
			**m_bselInPorts,	**m_bselOutPorts,
			**m_dataCPUInPorts,	**m_dataCPUOutPorts,
			**m_dataBusInPorts,	**m_dataBusOutPorts; 		
			
	const static unsigned long long
							 m_addrWidth = 32,
							 m_dataWidth = 32,
							 m_bselWidth = 4,
							 m_byteSize = m_dataWidth/m_bselWidth;

	Time m_responseTime;
	
	enum State {waiting,sending, forwarding, cleanup};

	State m_state;
	State m_forwardingState;
	



	
	unsigned long long m_minAddrSpaceLimit;
	unsigned long long m_maxAddrSpaceLimit;
	
	bit		*m_ctlIn,
			*m_addrIn, 
			*m_bselIn, 
			*m_dataCPUIn,
			*m_dataBusIn;			
			
	o_bit 	*m_ctlOut, 
			*m_addrOut, 
			*m_bselOut, 
			*m_dataCPUOut,
			*m_dataBusOut;		
	
};

#endif
