/*******************************************************************
*
*  DESCRIPTION: Atomic Model Latch
*
*  AUTHOR: Mario Bergotto & Tomas Heredia 
*
*  EMAIL: mailto://mbergott@dc.uba.ar
*         mailto://theredia@dc.uba.ar,tomas@intermedia.com.ar
*
*******************************************************************/

/** my include files **/
#include "Latch.h"      // class Cwplogic
#include <message.h>    // class ExternalMessage, InternalMessage
#include <mainsimu.h>   // MainSimulator::Instance().getParameter( ... )
/** public functions **/

/*******************************************************************
* Function Name: Latch
* Description: 
********************************************************************/
Latch::Latch( const string &name )
: Atomic( name )
, in0( this->addInputPort( "in0" ) )
, in1( this->addInputPort( "in1" ) )
, in2( this->addInputPort( "in2" ) )
, in3( this->addInputPort( "in3" ) )

, in4( this->addInputPort( "in4" ) )

, in5( this->addInputPort( "in5" ) )

, in6( this->addInputPort( "in6" ) )

, in7( this->addInputPort( "in7" ) )

, in8( this->addInputPort( "in8" ) )

, in9( this->addInputPort( "in9" ) )

, in10( this->addInputPort( "in10" ) )

, in11( this->addInputPort( "in11" ) )

, in12( this->addInputPort( "in12" ) )

, in13( this->addInputPort( "in13" ) )

, in14( this->addInputPort( "in14" ) )

, in15( this->addInputPort( "in15" ) )

, in16( this->addInputPort( "in16" ) )

, in17( this->addInputPort( "in17" ) )

, in18( this->addInputPort( "in18" ) )

, in19( this->addInputPort( "in19" ) )

, in20( this->addInputPort( "in20" ) )

, in21( this->addInputPort( "in21" ) )

, in22( this->addInputPort( "in22" ) )

, in23( this->addInputPort( "in23" ) )

, in24( this->addInputPort( "in24" ) )

, in25( this->addInputPort( "in25" ) )

, in26( this->addInputPort( "in26" ) )

, in27( this->addInputPort( "in27" ) )

, in28( this->addInputPort( "in28" ) )

, in29( this->addInputPort( "in29" ) )

, in30( this->addInputPort( "in30" ) )

, in31( this->addInputPort( "in31" ) )



, ein( this->addInputPort( "ein" ) )

, clear( this->addInputPort( "clear" ) )



, out0( this->addOutputPort( "out0" ) )

, out1( this->addOutputPort( "out1" ) )

, out2( this->addOutputPort( "out2" ) )

, out3( this->addOutputPort( "out3" ) )

, out4( this->addOutputPort( "out4" ) )

, out5( this->addOutputPort( "out5" ) )

, out6( this->addOutputPort( "out6" ) )

, out7( this->addOutputPort( "out7" ) )

, out8( this->addOutputPort( "out8" ) )

, out9( this->addOutputPort( "out9" ) )

, out10( this->addOutputPort( "out10" ) )

, out11( this->addOutputPort( "out11" ) )

, out12( this->addOutputPort( "out12" ) )

, out13( this->addOutputPort( "out13" ) )

, out14( this->addOutputPort( "out14" ) )

, out15( this->addOutputPort( "out15" ) )

, out16( this->addOutputPort( "out16" ) )

, out17( this->addOutputPort( "out17" ) )

, out18( this->addOutputPort( "out18" ) )

, out19( this->addOutputPort( "out19" ) )

, out20( this->addOutputPort( "out20" ) )

, out21( this->addOutputPort( "out21" ) )

, out22( this->addOutputPort( "out22" ) )

, out23( this->addOutputPort( "out23" ) )

, out24( this->addOutputPort( "out24" ) )

, out25( this->addOutputPort( "out25" ) )

, out26( this->addOutputPort( "out26" ) )

, out27( this->addOutputPort( "out27" ) )

, out28( this->addOutputPort( "out28" ) )

, out29( this->addOutputPort( "out29" ) )

, out30( this->addOutputPort( "out30" ) )

, out31( this->addOutputPort( "out31" ) )

, preparationTime( 0, 0, 1, 0)
, initial( 0 )
{

	if (MainSimulator::Instance().existsParameter( this->description(), "preparation") ) {

		string time( MainSimulator::Instance().getParameter( this->description(), "preparation" ) );

		if (time != "")

			preparationTime = time;

	}

	if (MainSimulator::Instance().existsParameter( this->description(), "initial") ) {
	  string ini( MainSimulator::Instance().getParameter( this->description(), "initial" ) );
	  if (ini != "")
	    initial = atoi( ini.c_str() );
	}

}









/*******************************************************************

* Function Name: initFunction

********************************************************************/

Model &Latch::initFunction()

{
	for ( int i = 0 ; i < 32 ; i++ ) {
	  outval[i] = ( initial & (1 << i) ) == 0 ? false : true;
	  choutval[i] = outval[i];
	}
	einval = false;
	clearval = false;
	this->holdIn( active, 0 );
	return *this ;
}


/*******************************************************************

* Function Name: externalFunction

* Description: 

********************************************************************/

Model &Latch::externalFunction( const ExternalMessage &msg )

{

	if( msg.port() == in0 )

	{

		inval[0] = msg.value();

	}

	if( msg.port() == in1 )

	{

		inval[1] = msg.value();

	}

	if( msg.port() == in2 )

	{

		inval[2] = msg.value();

	}

	if( msg.port() == in3 )

	{

		inval[3] = msg.value();

	}

	if( msg.port() == in4 )

	{

		inval[4] = msg.value();

	}

	if( msg.port() == in5 )

	{

		inval[5] = msg.value();

	}

	if( msg.port() == in6 )

	{

		inval[6] = msg.value();

	}

	if( msg.port() == in7 )

	{

		inval[7] = msg.value();

	}

	if( msg.port() == in8 )

	{

		inval[8] = msg.value();

	}

	if( msg.port() == in9 )

	{

		inval[9] = msg.value();

	}

	if( msg.port() == in10 )

	{

		inval[10] = msg.value();

	}

	if( msg.port() == in11 )

	{

		inval[11] = msg.value();

	}

	if( msg.port() == in12 )

	{

		inval[12] = msg.value();

	}

	if( msg.port() == in13 )

	{

		inval[13] = msg.value();

	}

	if( msg.port() == in14 )

	{

		inval[14] = msg.value();

	}

	if( msg.port() == in15 )

	{

		inval[15] = msg.value();

	}

	if( msg.port() == in16 )

	{

		inval[16] = msg.value();

	}

	if( msg.port() == in17 )

	{

		inval[17] = msg.value();

	}

	if( msg.port() == in18 )

	{

		inval[18] = msg.value();

	}

	if( msg.port() == in19 )

	{

		inval[19] = msg.value();

	}

	if( msg.port() == in20 )

	{

		inval[20] = msg.value();

	}

	if( msg.port() == in21 )

	{

		inval[21] = msg.value();

	}

	if( msg.port() == in22 )

	{

		inval[22] = msg.value();

	}

	if( msg.port() == in23 )

	{

		inval[23] = msg.value();

	}

	if( msg.port() == in24 )

	{

		inval[24] = msg.value();

	}

	if( msg.port() == in25 )

	{

		inval[25] = msg.value();

	}

	if( msg.port() == in26 )

	{

		inval[26] = msg.value();

	}

	if( msg.port() == in27 )

	{

		inval[27] = msg.value();

	}

	if( msg.port() == in28 )

	{

		inval[28] = msg.value();

	}

	if( msg.port() == in29 )

	{

		inval[29] = msg.value();

	}

	if( msg.port() == in30 )

	{

		inval[30] = msg.value();

	}

	if( msg.port() == in31 )

	{

		inval[31] = msg.value();

	}

		

	if( msg.port() == ein )

	{

		einval = msg.value();

	}

	

	if( msg.port() == clear )

	{

		oldclearval = clearval;

		clearval = msg.value();

	}



	if (clearval && (oldclearval != clearval))

	{

		for ( int i = 0 ; i < 32 ; i++ )

		{

			oldoutval[i] = outval[i];

			outval[i] = false;

			choutval[i] |= ( oldoutval[i] != outval[i] );

		}

	}

	if (einval && !clearval)

	{

		for ( int i = 0 ; i < 32 ; i++ )

		{

			oldoutval[i] = outval[i];	

			outval[i] = inval[i];

			choutval[i] |= ( oldoutval[i] != outval[i] );

		}	

	}



	booltmp = false;

	for ( int i = 0 ; i < 32 ; i++ )

		booltmp |= choutval[i];



	if ( booltmp )

		this->holdIn( active, preparationTime );

	return *this;

}



/*******************************************************************

* Function Name: internalFunction

* Description: 

********************************************************************/

Model &Latch::internalFunction( const InternalMessage & )

{

	this->passivate();

	return *this ;

}





/*******************************************************************

* Function Name: outputFunction

* Description: 

********************************************************************/

Model &Latch::outputFunction( const InternalMessage &msg )

{

	if ( choutval[0] )

	{

		this->sendOutput( msg.time(), out0, outval[0] ) ;

		choutval[0] = false;

	}

	if ( choutval[1] )

	{

		this->sendOutput( msg.time(), out1, outval[1] ) ;

		choutval[1] = false;

	}

	if ( choutval[2] )

	{

		this->sendOutput( msg.time(), out2, outval[2] ) ;

		choutval[2] = false;

	}

	if ( choutval[3] )

	{

		this->sendOutput( msg.time(), out3, outval[3] ) ;

		choutval[3] = false;

	}

	if ( choutval[4] )

	{

		this->sendOutput( msg.time(), out4, outval[4] ) ;

		choutval[4] = false;

	}

	if ( choutval[5] )

	{

		this->sendOutput( msg.time(), out5, outval[5] ) ;

		choutval[5] = false;

	}

	if ( choutval[6] )

	{

		this->sendOutput( msg.time(), out6, outval[6] ) ;

		choutval[6] = false;

	}

	if ( choutval[7] )

	{

		this->sendOutput( msg.time(), out7, outval[7] ) ;

		choutval[7] = false;

	}

	if ( choutval[8] )

	{

		this->sendOutput( msg.time(), out8, outval[8] ) ;

		choutval[8] = false;

	}

	if ( choutval[9] )

	{

		this->sendOutput( msg.time(), out9, outval[9] ) ;

		choutval[9] = false;

	}

	if ( choutval[10] )

	{

		this->sendOutput( msg.time(), out10, outval[10] ) ;

		choutval[10] = false;

	}

	if ( choutval[11] )

	{

		this->sendOutput( msg.time(), out11, outval[11] ) ;

		choutval[11] = false;

	}

	if ( choutval[12] )

	{

		this->sendOutput( msg.time(), out12, outval[12] ) ;

		choutval[12] = false;

	}

	if ( choutval[13] )

	{

		this->sendOutput( msg.time(), out13, outval[13] ) ;

		choutval[13] = false;

	}

	if ( choutval[14] )

	{

		this->sendOutput( msg.time(), out14, outval[14] ) ;

		choutval[14] = false;

	}

	if ( choutval[15] )

	{

		this->sendOutput( msg.time(), out15, outval[15] ) ;

		choutval[15] = false;

	}

	if ( choutval[16] )

	{

		this->sendOutput( msg.time(), out16, outval[16] ) ;

		choutval[16] = false;

	}

	if ( choutval[17] )

	{

		this->sendOutput( msg.time(), out17, outval[17] ) ;

		choutval[17] = false;

	}

	if ( choutval[18] )

	{

		this->sendOutput( msg.time(), out18, outval[18] ) ;

		choutval[18] = false;

	}

	if ( choutval[19] )

	{

		this->sendOutput( msg.time(), out19, outval[19] ) ;

		choutval[19] = false;

	}

	if ( choutval[20] )

	{

		this->sendOutput( msg.time(), out20, outval[20] ) ;

		choutval[20] = false;

	}

	if ( choutval[21] )

	{

		this->sendOutput( msg.time(), out21, outval[21] ) ;

		choutval[21] = false;

	}

	if ( choutval[22] )

	{

		this->sendOutput( msg.time(), out22, outval[22] ) ;

		choutval[22] = false;

	}

	if ( choutval[23] )

	{

		this->sendOutput( msg.time(), out23, outval[23] ) ;

		choutval[23] = false;

	}

	if ( choutval[24] )

	{

		this->sendOutput( msg.time(), out24, outval[24] ) ;

		choutval[24] = false;

	}

	if ( choutval[25] )

	{

		this->sendOutput( msg.time(), out25, outval[25] ) ;

		choutval[25] = false;

	}

	if ( choutval[26] )

	{

		this->sendOutput( msg.time(), out26, outval[26] ) ;

		choutval[26] = false;

	}

	if ( choutval[27] )

	{

		this->sendOutput( msg.time(), out27, outval[27] ) ;

		choutval[27] = false;

	}

	if ( choutval[28] )

	{

		this->sendOutput( msg.time(), out28, outval[28] ) ;

		choutval[28] = false;

	}

	if ( choutval[29] )

	{

		this->sendOutput( msg.time(), out29, outval[29] ) ;

		choutval[29] = false;

	}

	if ( choutval[30] )

	{

		this->sendOutput( msg.time(), out30, outval[30] ) ;

		choutval[30] = false;

	}

	if ( choutval[31] )

	{

		this->sendOutput( msg.time(), out31, outval[31] ) ;

		choutval[31] = false;

	}



	return *this ;

}

