/*******************************************************************

*

*  DESCRIPTION: Atomic Model Latch

*

*  AUTHOR: Mario Bergotto & Tomas Heredia 

*

*  EMAIL: mailto://mbergott@dc.uba.ar

*         mailto://theredia@dc.uba.ar,tomas@intermedia.com.ar

*

*******************************************************************/



#ifndef __LATCH_H

#define __LATCH_H



#include <atomic.h>     // class Atomic



class Latch : public Atomic

{

public:

	Latch( const string &name = "Latch" );					//Default constructor



	virtual string className() const ;

protected:

	Model &initFunction();

	Model &externalFunction( const ExternalMessage & );

	Model &internalFunction( const InternalMessage & );

	Model &outputFunction( const InternalMessage & );



private:

	const Port &in0;

	const Port &in1;

	const Port &in2;

	const Port &in3;

	const Port &in4;

	const Port &in5;

	const Port &in6;

	const Port &in7;

	const Port &in8;

	const Port &in9;

	const Port &in10;

	const Port &in11;

	const Port &in12;

	const Port &in13;

	const Port &in14;

	const Port &in15;

	const Port &in16;

	const Port &in17;

	const Port &in18;

	const Port &in19;

	const Port &in20;

	const Port &in21;

	const Port &in22;

	const Port &in23;

	const Port &in24;

	const Port &in25;

	const Port &in26;

	const Port &in27;

	const Port &in28;

	const Port &in29;

	const Port &in30;

	const Port &in31;



	const Port &ein;



	const Port &clear;



	Port &out0;

	Port &out1;

	Port &out2;

	Port &out3;

	Port &out4;

	Port &out5;

	Port &out6;

	Port &out7;

	Port &out8;

	Port &out9;

	Port &out10;

	Port &out11;

	Port &out12;

	Port &out13;

	Port &out14;

	Port &out15;

	Port &out16;

	Port &out17;

	Port &out18;

	Port &out19;

	Port &out20;

	Port &out21;

	Port &out22;

	Port &out23;

	Port &out24;

	Port &out25;

	Port &out26;

	Port &out27;

	Port &out28;

	Port &out29;

	Port &out30;

	Port &out31;



	Time preparationTime;

	

	bool inval[32];

	bool outval[32];

	bool oldoutval[32];

	bool choutval[32];

	bool einval;

	bool clearval;

	bool oldclearval;

	bool booltmp;

	int initial;




};	// class Cwplogic



// ** inline ** // 

inline

string Latch::className() const

{

	return "Latch" ;

}





#endif   //__LATCH_H

