#include "ALU/ALU.h"
#include "AND/AND.h"
#include "Adder/Adder.h"
#include "AlignL/AlignL.h"
#include "AlignS/AlignS.h"
#include "Bus/Bus.h"
#include "CCLogic/CCLogic.h"
#include "CS/CS.h"
#include "CWPlogic/CWPlogic.h"
#include "Clock/Clock.h"
#include "Cmp/Cmp.h"
#include "FromDeci/FromDeci.h"
#include "IRQLogic/IRQLogic.h"
#include "Inc4/Inc4.h"
#include "IncDec/IncDec.h"
#include "Latch/Latch.h"
#include "Mem/Mem.h"
#include "MulDiv/MulDiv.h"
#include "Mux/Mux.h"
#include "MuxN/MuxN.h"
#include "NOT/NOT.h"
#include "RegBlock/RegBlock.h"
#include "RegGlob/RegGlob.h"
#include "Shifter/Shifter.h"
#include "SignExtN/SignExtN.h"
#include "TestIn/TestIn.h"
#include "TestOut/TestOut.h"
#include "ToDeci/ToDeci.h"
#include "TrapLogic/TrapLogic.h"
#include "UC/UC.h"
#include "UCTest/UCTest.h"
#include "WIMCheck/WIMCheck.h"

#include "../simu/modeladm.h" 
#include "../simu/mainsimu.h"
void MainSimulator::registerNewAtomics()
{

  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<ALU>()     , "ALU" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<AND>()     , "AND" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Adder>()     , "Adder" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<AlignL>()     , "AlignL" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<AlignS>()     , "AlignS" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Bus>()     , "Bus" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<CCLogic>()     , "CCLogic" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<CS>()     , "CS" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<CWPlogic>()     , "CWPlogic" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Clock>()     , "Clock" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Cmp>()     , "Cmp" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<FromDeci>()     , "FromDeci" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<IRQLogic>()     , "IRQLogic" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Inc4>()     , "Inc4" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<IncDec>()     , "IncDec" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Latch>()     , "Latch" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Mem>()     , "Mem" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<MulDiv>()     , "MulDiv" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Mux>()     , "Mux" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<MuxN>()     , "MuxN" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<NOT>()     , "NOT" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<RegBlock>()     , "RegBlock" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<RegGlob>()     , "RegGlob" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Shifter>()     , "Shifter" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<SignExtN>()     , "SignExtN" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<TestIn>()     , "TestIn" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<TestOut>()     , "TestOut" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<ToDeci>()     , "ToDeci" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<TrapLogic>()     , "TrapLogic" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<UC>()     , "UC" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<UCTest>()     , "UCTest" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<WIMCheck>()     , "WIMCheck" ) ;
}
