/*******************************************************************
*
*  DESCRIPTION: CLASS EvalDebug
*
*  AUTHOR:    Daniel Rodriguez.
*
*  EMAIL: mailto://drodrigu@dc.uba.ar
*
*  DATE: 01/06/1999
*
*******************************************************************/

#ifndef __EVAL_DEBUG_H
#define __EVAL_DEBUG_H

/** definitions **/
#include <ostream.h>
#include <stdlib.h>

class clsEvalDebug
{
public:
	clsEvalDebug()				//Default constructor
		:evalDebugOut(NULL)
		,evalDebugActive(false)
		{}

	ostream &Stream()
			{return *evalDebugOut;}
			
	void Stream( ostream *evalDebugStr )
			{ evalDebugOut = evalDebugStr; }

	const bool Active()
			{return evalDebugActive;}
			
	void Active( bool mode )
			{ evalDebugActive = mode; }

protected:
	// ** Instance variables ** //
	ostream *evalDebugOut ;
	bool evalDebugActive ;

};	// class EvalDebug




extern clsEvalDebug	*evalDebugInstance;
extern clsEvalDebug	*flatDebugInstance;
extern clsEvalDebug	*rulesDebugInstance;
extern clsEvalDebug	*parserDebugInstance;
extern clsEvalDebug	*showVirtualTimeDebugInstance;



inline clsEvalDebug &ShowVirtualTimeWhenFinish()
{
	if (showVirtualTimeDebugInstance == NULL)
		showVirtualTimeDebugInstance = new clsEvalDebug;
	
	return *showVirtualTimeDebugInstance;
}	

inline clsEvalDebug &EvalDebug()
{
	if (evalDebugInstance == NULL)
		evalDebugInstance = new clsEvalDebug;
	
	return *evalDebugInstance;
}	

inline clsEvalDebug &FlatDebug()
{
	if (flatDebugInstance == NULL)
		flatDebugInstance = new clsEvalDebug;
	
	return *flatDebugInstance;
}	

inline clsEvalDebug &DebugCellRules()
{
	if (rulesDebugInstance == NULL)
		rulesDebugInstance = new clsEvalDebug;
	
	return *rulesDebugInstance;
}	

inline clsEvalDebug &ParserDebug()
{
	if (parserDebugInstance == NULL)
		parserDebugInstance = new clsEvalDebug;
	
	return *parserDebugInstance;
}	

#endif   //__EVAL_DEBUG_H 
